(* 
   Figures J. Carmona, J. Julvez, J. Cortadella and M. Kishinevsky, 
   "Scheduling Synchronous Elastic Designs," ACSD 09 
*)


let node ip_2_1 ((x::'a), (y::'a)) = x
let node ip_2_2 ((x::'a), (y::'a)) = (x, x)
let node relay x = x

(* ----------------------------*)
(* Figure 0.(a)                *)
(* ----------------------------*)

let node ip_A (x, y) = ip_2_1 (x, y)
let node ip_B (x, y) = ip_2_1 (x, y)
let node ip_C x = (x, x)
let node ip_D x = (x, x)

let node figure0_a i = o where
  rec out_A = ip_A (buffer in_A0, buffer in_A1)
  and out_B = ip_B (buffer in_B0, buffer in_B1)
  and out_C0, out_C1 = ip_C (buffer in_C)
  and out_D0, out_D1 = ip_D (buffer in_D)
  and o = out_D1

  and in_A0 = i
  and in_A1 = merge 1(0) 4012 (delay out_C0)
  and in_B0 = merge 1(0) 4012 (delay out_A)
  and in_B1 = merge 1(0) 4012 (delay out_D0)
  and in_C = merge 1(0) 4012 (delay out_B)
  and in_D = merge 1(0) 4012 (delay out_C1)


(* ----------------------------*)
(* Figure 0.(b)                *)
(* ----------------------------*)
let node figure0_b i = o where
  rec out_A = ip_A (buffer in_A0, buffer in_A1)
  and out_B = ip_B (buffer in_B0, buffer in_B1)
  and out_C0, out_C1 = ip_C (buffer in_C)
  and out_D0, out_D1 = ip_D (buffer in_D)
  and o = out_D1

  and in_A0 = i
  and in_A1 = delay (relay (delay (relay (merge 1(0) 4012 (delay out_C0)))))
  and in_B0 = merge 1(0) 4012 (delay out_A)
  and in_B1 = delay (relay (merge 1(0) 4012 (delay out_D0)))
  and in_C = merge 1(0) 4012 (delay out_B)
  and in_D = merge 1(0) 4012 (delay out_C1)


(* ----------------------------*)
(* Figure 1.(c)                *)
(* ----------------------------*)

let node a (x, y) = ip_2_2 (x, y)
let node b x = x
let node c x = x
let node d (x, y) = ip_2_2 (x, y)
let node e x = x
let node f x = x
let node g x = x
let node h (x, y) = ip_2_1 (x, y)
let node i x = x
let node j x = x

let node figure1_c input = o where 
  rec out_a0, out_a1 = a (input, buffer in_a)
  and out_b = b (buffer in_b)
  and out_c = c (buffer in_c)
  and out_d0, out_d1 = b (buffer in_d0, buffer in_d1) 
  and out_e = e (buffer in_e)
  and out_f = f (buffer in_f)
  and out_g = g (buffer in_g)
  and out_h = h (buffer in_h0, buffer in_h1)
  and out_i = i (buffer in_i)
  and out_j = j (buffer in_j)
  and o = out_d0

  and in_a = merge 1(0) 4012 (delay out_e)
  and in_b = merge 11(0) 4012 (delay out_a1)
  and in_c = delay out_b
  and in_d0 = merge 1(0) 4012 (delay out_h)
  and in_d1 = delay out_c
  and in_e = delay out_d0
  and in_f = merge 1(0) 4012 (delay out_a0)
  and in_g = merge 1(0) 4012 (delay out_f)
  and in_h0 = merge 1(0) 4012 (delay out_g)
  and in_h1 = merge 11(0) 4012 (delay out_j)
  and in_i = merge 11(0) 4012 (delay out_d1)
  and in_j = merge 11(0) 4012 (delay out_i)

(* ----------------------------*)
(* Figure 1.(d)                *)
(* ----------------------------*)

let node figure1_c input = o where 
  rec out_a0, out_a1 = a (input, buffer in_a)
  and out_b = b (buffer in_b)
  and out_c = c (buffer in_c)
  and out_d0, out_d1 = b (buffer in_d0, buffer in_d1) 
  and out_e = e (buffer in_e)
  and out_f = f (buffer in_f)
  and out_g = g (buffer in_g)
  and out_h = h (buffer in_h0, buffer in_h1)
  and out_i = i (buffer in_i)
  and out_j = j (buffer in_j)
  and o = out_d0

  and in_a = merge 1(0) 4012 (delay out_e)
  and in_b = merge 11(0) 4012 (delay out_a1)
  and in_c = delay out_b
  and in_d0 = merge 1(0) 4012 (delay out_h)
  and in_d1 = delay out_c
  and in_e = delay out_d0
  and in_f = merge 1(0) 4012 (delay out_a0)
  and in_g = merge 1(0) 4012 (delay out_f)
  and in_h0 = merge 1(0) 4012 (delay out_g)
  and in_h1 = merge 11(0) 4012 (delay out_j)
  and in_i = merge 11(0) 4012 (delay out_d1)
  and in_j = delay (merge 11(0) 4012 (delay out_i))

